Attribute VB_Name = "PlotXy"
Public X0, Y0, X1, Y1 As Long
Public X_Axis_Min, X_Axis_Max, Y_Axis_Min, Y_Axis_Max As Double
Public X_Tic_Number, Y_Tic_Number As Integer
Public Pr_X, Pr_Y As Double
Public Cur_X, Cur_Y As Double

Public Sub InitGraph(frm As Form, X_Min, X_Max, Y_Min, Y_Max, X_Tic, Y_Tic)

Dim MyForecolor As Long         'Set graph's color. Can use QBColor or RGB() function
MyForecolor = RGB(0, 0, 0)      '

X0 = 1500                       'Set the public variables
Y0 = frm.Height - 1500          'for the graph window. X0,Y0,X1,Y1 are
X1 = frm.Width - 400            'actual form coordinates in twips
Y1 = 300                        '
X_Axis_Min = X_Min              'Axis limits that may change according
X_Axis_Max = X_Max              'to the actual X,Y data values
Y_Axis_Min = Y_Min              'given later in PlotData() function
Y_Axis_Max = Y_Max
X_Tic_Number = X_Tic
Y_Tic_Number = Y_Tic

frm.AutoRedraw = True                   'Need this so that a box is drawn when frm loads.
frm.BackColor = RGB(255, 255, 255)
frm.ForeColor = MyForecolor
frm.DrawStyle = 0                       'DrawStyle is solid line
frm.Cls

frm.Line (X0, Y0)-(X1, Y1), , B         'Draw a box

'Draw X-Tics
x_inc = (X1 - X0) / X_Tic_Number
tic_val_x = (X_Axis_Max - X_Axis_Min) / X_Tic_Number
tic_y = Y1
frm.DrawStyle = 2                       'DrawStyle is now dots
For i = 1 To X_Tic_Number + 1
    tic_x = X0 + (i - 1) * x_inc
    frm.Line (tic_x, Y0)-(tic_x, tic_y)
    frm.CurrentX = tic_x - 120
    frm.CurrentY = Y0 + 200
    frm.Print Str(X_Axis_Min + (i - 1) * tic_val_x)
Next i

'Draw Y-Tics
y_inc = (Y0 - Y1) / Y_Tic_Number
tic_val_y = (Y_Axis_Max - Y_Axis_Min) / Y_Tic_Number
tic_x = X1
For i = 1 To Y_Tic_Number + 1
    tic_y = Y1 + (i - 1) * y_inc
    frm.Line (tic_x, tic_y)-(X0, tic_y)
    frm.CurrentX = X0 - 450
    frm.CurrentY = tic_y - 50
    frm.Print Str(Y_Axis_Max - (i - 1) * tic_val_y)
Next i
frm.DrawStyle = 0

Pr_X = -100
Pr_Y = -100

End Sub
Public Sub PlotData(frm As Form, XData As Double, YData As Double, pltColor As Long)

x_height = X_Axis_Max - X_Axis_Min
y_height = Y_Axis_Max - Y_Axis_Min

Xoffset = XData - X_Axis_Min
Yoffset = YData - Y_Axis_Min

If (Xoffset >= 0) And (Yoffset >= 0) Then
    percent_data_x = Xoffset / x_height
    percent_data_y = Yoffset / y_height
    
    x_data_screen = X0 + ((X1 - X0) * percent_data_x)
    y_data_screen = Y0 - ((Y0 - Y1) * percent_data_y)
    
    If Pr_X = -100 Or Pr_Y = -100 Then
        Pr_X = x_data_screen
        Pr_Y = y_data_screen
        Exit Sub
    End If
    
    frm.Line (Pr_X, Pr_Y)-(x_data_screen, y_data_screen), pltColor
    Pr_X = x_data_screen
    Pr_Y = y_data_screen
End If

End Sub
Public Sub RePlot(frm As Form, XArr() As Double, YArr() As Double, MyColor As Long)

Xupper = UBound(XArr)
PlotColor = pltColor

For i = 1 To Xupper
    PlotData frm, XArr(i), YArr(i), MyColor
Next i
End Sub
