Attribute VB_Name = "PlotXy2"
Public X0, Y0, X1, Y1 As Long
Public X_Min, X_Max, Y1_Min, Y1_Max, Y2_Min, Y2_Max As Double
Public X_Tic, Y1_Tic, Y2_Tic As Integer

Public Sub InitGraph(frm As Form, X_n, X_x, Y1_n, Y1_x, Y2_n, Y2_x, X_T, Y1_T, Y2_T)

Dim MyForecolor As Long         'Set graph's color. Can use QBColor or RGB() function
MyForecolor = RGB(0, 0, 0)      '

X0 = 1200                       'Set the public variables
Y0 = frm.Height - 1700          'for the graph window. X0,Y0,X1,Y1 are
X1 = frm.Width - 1500            'actual form coordinates in twips
Y1 = 300                        '
X_Min = X_n              'Axis limits that may change according
X_Max = X_x              'to the actual X,Y data values
Y1_Min = Y1_n              'given later in PlotData() function
Y1_Max = Y1_x
Y2_Min = Y2_n
Y2_Max = Y2_x
X_Tic = X_T
Y1_Tic = Y1_T
Y2_Tic = Y2_T

frm.AutoRedraw = True                   'Need this so that a box is drawn when frm loads.
frm.BackColor = RGB(255, 255, 255)
frm.ForeColor = MyForecolor
frm.DrawStyle = 0                       'DrawStyle is solid line
frm.Cls

frm.Line (X0, Y0)-(X1, Y1), , B         'Draw a box

'Draw X-Tics
x_inc = (X1 - X0) / X_Tic
tic_val_x = (X_Max - X_Min) / X_Tic
tic_y = Y0 + 100

For i = 1 To X_Tic + 1
    tic_x = X0 + (i - 1) * x_inc
    frm.Line (tic_x, Y0)-(tic_x, tic_y)
    frm.CurrentX = tic_x - 120
    frm.CurrentY = Y0 + 200
    frm.Print Str(X_Min + (i - 1) * tic_val_x)
Next i

'Draw first Y Axis-Tics (Y1)

y1_inc = (Y0 - Y1) / Y1_Tic
tic_val_y1 = (Y1_Max - Y1_Min) / Y1_Tic
tic_x = X0 - 100
For i = 1 To Y1_Tic + 1
    tic_y1 = Y1 + (i - 1) * y1_inc
    frm.Line (tic_x, tic_y1)-(X0, tic_y1)
    frm.CurrentX = X0 - 450
    frm.CurrentY = tic_y1 - 50
    frm.Print Str(Y1_Max - (i - 1) * tic_val_y1)
Next i

'Draw second Y Axis-Tics (Y2)

y2_inc = (Y0 - Y1) / Y2_Tic
tic_val_y2 = (Y2_Max - Y2_Min) / Y2_Tic
tic_x = X1 + 100
For i = 1 To Y2_Tic + 1
    tic_y2 = Y1 + (i - 1) * y2_inc
    frm.Line (tic_x, tic_y2)-(X1, tic_y2)
    frm.CurrentX = X1 + 250
    frm.CurrentY = tic_y2 - 50
    frm.Print Str(Y2_Max - (i - 1) * tic_val_y2)
Next i

End Sub
Public Sub PlotData(frm As Form, XData As Double, YData As Double, TicStr As String, pltColor As Long, AxisNumber As Integer)

x_height = X_Max - X_Min
Xoffset = XData - X_Min
PltAxis = AxisNumber

If PltAxis = 1 Then                'If Fist Y-Axis
    Yoffset = YData - Y1_Min
    y_height = Y1_Max - Y1_Min
ElseIf PltAxis = 2 Then            'If Second Y-Axis
    Yoffset = YData - Y2_Min
    y_height = Y2_Max - Y2_Min
End If

If (Xoffset >= 0) And (Yoffset >= 0) Then
    percent_data_x = Xoffset / x_height
    percent_data_y = Yoffset / y_height
    
    x_data_screen = X0 + ((X1 - X0) * percent_data_x)
    y_data_screen = Y0 - ((Y0 - Y1) * percent_data_y)
    
    frm.CurrentX = x_data_screen - 50
    frm.CurrentY = y_data_screen - 100
    frm.ForeColor = pltColor
    frm.Print TicStr
End If

End Sub

Public Sub RePlot(frm As Form, XArr() As Double, YArr() As Double, TicStr As String, pltColor As Long, AxisNumber As Integer)

Dim TicString As String
Dim PlotColor As Long
Dim AxisNum As Integer

Xupper = UBound(XArr)
TicString = TicStr
PlotColor = pltColor
AxisNum = AxisNumber

For i = 1 To Xupper
    PlotData frm, XArr(i), YArr(i), TicString, PlotColor, AxisNum
Next i
End Sub
